<template>
    <div class="common-playful" :class="{ 'is-has-announcement': !noNotifyHeaderPages.some((v) => $route.path.toLowerCase().startsWith(v)) }">
      <div v-if="isAllowAnnouncement" class="sticky top-0 w-full z-[99]">
        <header-m-main :theme-properties="themeProperties" :auth="authentication" :actived-tab="included"  />
        <div class="px-2 bg-background2 sticky top-0 z-50 main-announcement">
          <div v-if="!noNotifyHeaderPages.some((v) => $route.path.toLowerCase().startsWith(v))" class="min-h-[unset] mx-auto">
            <div class="flex gap-1 py-2 items-center relative z-50">
              <button class="drawer-btn" @click="drawer = true">
                  <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
              </button>
              <Teleport to="body">
                <el-drawer
                  :show-close="false"
                  direction="ltr"
                  v-model="drawer"
                  title="Menu"
                  size="320px"
                  class="menu-drawer"
                  :destroy-on-close="true">
                  <template #header>
                    <div class="header-drawer">
                        <button class="drawer-close-btn flex justify-center items-center" @click="drawer = false">
                            <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
                        </button>
                    </div>
                  </template>
                  <lazy-theme-desktop-playful-components-leftside-drawer v-model:is-drawer-opened="drawer"/>
                </el-drawer>
              </Teleport>
              <div class="px-4 py-2 bg-background5 rounded-lg h-[40px]" :class="isMobile ? 'w-full' : 'w-[87%]'">
                <utils-announcement
                  v-if="!announcement.IsHidden"
                  :announcement="announcement.Text"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="flex">
        <div class="w-full left-container">
          <div class="mx-auto">
            <BannerMobileRender
              v-if="isAllowBannerRoute && !isIndependentModule"
              :actived-tab="activedTab"
              :banner-keys="bannerKeys"
            />
            <slot container-class="w-full mx-auto" />
          </div>
        </div>
      </div>
      <div v-if="except">
        <lazy-footer template="playful" layout="mobile"/>
      </div>
      <new-black-theme-agent-cooperation-dialog />
      <new-black-theme-register-dialog v-if="!register.IsHidden && !isRegister" />
      <new-black-theme-login-dialog />
      <new-black-theme-sidebar />
    </div>
  </template>
  <script lang="ts">
  import _ from "lodash";
  import { defineComponent, computed } from "vue";
  import { store } from "@/store";
  import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
  import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

  export default defineComponent({
    name: "App",
    setup() {
      const isMobile = useDevice().isMobile;
      const themeProperties = computed(
        () => store.state.companyThemePropertiesFromApi.ThemeProperties
      );
      const register = computed(() =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "register"
        )
      );
      const authentication = computed(() => store.state.auth);
      const isLoading = computed(() => store.state.isThemePropertyLoading);
      const route = useRoute();
      const array: Array<string> = [
        "bethistory",
        "deposit",
        "wallet",
        "account",
        "aboutus",
        "transaction-history",
        "withdrawal",
        "referral",
        "helpcenter",
      ];
      const gameLobby: Array<string> = [
        "sports",
        "virtualsports",
        "livecasino",
        "games",
        "keno",
        "cockfight",
        "lottery",
        "poker",
      ];
      const tabSelectedLobby = computed(() =>
        _.replace(_.replace(route.path.split("/")[1], "-", ""), "/", "")
      );
      const activedTab = computed(() =>
        tabSelectedLobby.value !== "" ? tabSelectedLobby.value : "Home"
      );
      const included = computed(() =>
        _.includes(gameLobby, _.toLower(activedTab.value))
      );
      const isGameLoading = computed(() => store.state.isGameUpdateLoading);
      const tabSelected = computed(() =>
        _.replace(
          _.replace(route.path.split("/")[1], "-", ""),
          "/",
          ""
        ).toLowerCase()
      );
      const except = computed(() => !_.includes(array, tabSelected.value));
      const isRegister = computed(() => useRoute().name === 'register');
      const bannerKeys: Record<string, string> = {
        home: "lobby_banner_",
        virtualsports: "virtual_sport_banner_",
        livecasino: "live_casino_banner_",
        games: "game_banner_",
        poker: "poker_banner_",
        lottery: "lottery_banner_",
        cockfight: "cockfight_banner_",
        promotion: "promotion_banner_",
      };
      const allPages: Array<string> = [
        "home",
        "sports",
        "virtualsports",
        "livecasino",
        "games",
        "keno",
        "cockfight",
        "lottery",
        "poker",
        "promotion",
      ];
      const bannerPages = allPages.filter((page) => page !== "sports");
      const bannerShouldDisplay = computed(() =>
        _.includes(bannerPages, _.toLower(activedTab.value))
      );
      const announcement = computed(
        (): IThemePropertiesFromApi =>
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            EnumThemePropertyKey.announcement
          )
      );
      const isPromotionPage = computed(() => {
        return route.path.includes('my-promotion');
      });
      const drawer = ref(false);
      const noNotifyHeaderPages = ['/wallet', '/bet-history', '/deposit', '/profile', '/account', '/withdrawal', '/transaction-history', '/referral', '/help-center', "/contact-us"]
      watch(() => route.fullPath, () => {
        drawer.value = false;
      }, {deep: true});

    const isAllowAnnouncement = computed(() => {
      return !isPromotionPage.value && !route.path.includes("messages");
    });
    onMounted(() => {
      useSetV2Layout();
    });
    const { isIndependentModule } = useIndependentModule();
    const allowBannerRoute = [
      "home",
      "sports",
      "virtualsports",
      "livecasino",
      "games",
      "keno",
      "cockfight",
      "lottery",
      "poker",
    ];

    const isAllowBannerRoute = computed(() =>
      _.includes(allowBannerRoute, _.toLower(activedTab.value))
    );
      return {
        noNotifyHeaderPages,
        themeProperties,
        isLoading,
        authentication,
        isGameLoading,
        except,
        register,
        included,
        activedTab,
        isRegister,
        announcement,
        bannerKeys,
        bannerShouldDisplay,
        drawer,
        isMobile,
        isPromotionPage,
        isAllowAnnouncement,
        isIndependentModule,
        isAllowBannerRoute
      };
    },
  });
  </script>
  <style lang="scss">
  body:not(.el-popup-parent--hidden) {
    overflow: auto !important;
  }
  [layout="playful"][data-device="mobile"] {
    .entry__container {
      height: auto !important;
    }
    .el-tabs__nav-wrap {
      padding: 0px;
    }
    // .app__wrapper-container {
    //   margin-top: 121px;
    //   margin-bottom: 0;
    // }
  }
  .playfull-promotion-container {
    height: auto !important;
  }

  .is-has-announcement {
    // .app__container {
    //   padding-top: 56px;
    // }
    
    // .app__wrapper-container {
    //   margin-top: 121px;
    //   margin-bottom: 65px;
    // }
    .home-playful .app__wrapper-container {
      margin-top: 0 !important;
    }
  }
  .menu-drawer  {
      .el-drawer__header {
        padding: 0;
        margin-bottom: 0;
        .header-drawer {
            padding: 16px;
            padding-bottom: 0px;
            background: linear-gradient(0deg, rgba(0, 0, 0, 0.25) 0%, rgba(0, 0, 0, 0.25) 100%), var(--background5);
        }
        .drawer-close-btn {
            padding: 4px;
            gap: 8px;
            height: 40px;
            width: 40px;
            border-radius: 8px;
            background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
        }

        .drawer-close-btn svg {
            fill: var(--text5, #fff);
            opacity: 0.5;
            transition: opacity 350ms ease;
        }
      }
    }
  </style>
  <style lang="scss">
  body {
    overflow: hidden;
  }
  @import "@/assets/styles/mobile/common.scss";
  [data-device="mobile"] {
    ::-webkit-scrollbar {
      display: none;
    }
  }
  .common-playful {
    .mobile-banner {
      margin-left: 8px;
      margin-right: 8px;
      padding-left: 0;
      padding-right: 0;

      .swiper-pagination {
        text-align: end;
        padding-right: 8px;
        .swiper-pagination-bullet {
          margin: 0 2px;
          width: 8px;
          height: 4px;
          border-radius: 4px;
          opacity: 1;
          background: var(--text5, #fff);
        }
        .swiper-pagination-bullet.swiper-pagination-bullet-active {
          background: var(--primary);
          opacity: 1;
          width: 24px;
        }
        //   .el-carousel__button {
        // }
        // .el-carousel__indicator.el-carousel__indicator--horizontal.is-active {
        //   .el-carousel__button {
        //   }
        // }
      }
    }
    .menu-nav-links {
        font-size: 12px;
      .uc-menu-tile {
        font-size: 12px;
      }
      .expand-language {
        .langauge-label {
          font-size: 12px;
        }
      }
    }
    .promotion-slider {
      .swiper-wrapper {
        .swiper-slide {
          justify-content: start;
          padding-right: 8px !important;
          & > a {
            width: 100%;
            .promotion-card-item {
              width: 100% !important;
            }
          }
        }
      }
    }
    .el-drawer__body {
      position: relative;
      .menu-drawer__title {
        position: sticky;
        top: 0;
        z-index: 10;
      }
      .menu-drawer__body {
        .player-info__block,.bg-background5 {
          border-radius: 8px;
        }
      }
      .el-scrollbar__wrap {
        overflow: hidden;
        height: unset !important;
        .el-scrollbar__bar {
          height: unset;
        }
      }
    }
    header {
      .bg-background3 {
        background: var(--background5);
        .mr-\[23px\] {
          margin: 0px;
        }
      }
      .border-b4 {
        border-bottom: 1px solid var(--border);
      }
    }
    .render-all-games {
      .py-2 {
        @apply py-1;
      }
    }
    .promotion-slider {
      margin: 8px 0px;
    }
    .promotion-card-item {
      width: 224px !important;
      height: 96px !important;
    }
    .game-entry-filter {
      // width: 100vw;
      .menu-main-content {
        overflow-x: scroll;
        overflow-y: hidden;
      }
    }
    .big-win-container {
      span {
        font-size: 12px;
      }
      .user-row {
        left: 0;
      }
      .user-row span {
        color: #FFFFFF;
      }
      .amount-row {
        padding-left: 0;
      }
      .amount-row span {
        color: var(--textBtn);
      }
      max-width: 120px;
      .top-part {
        width: 120px;
        height: 120px;
      }
    }
    .mobile-banner {
      .swiper.swiper-initialized {
        border-radius: 8px;
      }
    }
    .drawer-btn {
      display: flex;
      padding: 4px;
      align-items: center;
      justify-content: center;
      gap: 8px;
      height: 40px;
      width: 40px;
      border-radius: 8px;
      /* position: fixed; */
      rotate: 180deg;
      background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
      /* top: 86px; */
      z-index: 25;
      left: 15px;
    }
    .render-all-games {
      width: 100%;
    }
    .blog-game {
      .game-card-container {
        width: 100%;
        .game-card-image {
          height: 100%;
        }
        .game-name-label {
          font-size: 12px;
        }
      }
    }
    .balance {
      margin-right: 8px;
    }
    width: 100%;
    height: 100%;
    overflow: hidden;
    .text-tertiary {
      color: var(--tertiary);
    }
    .mb-\[12vw\] {
      height: calc(100vh - 53px);
      height: calc(100svh - 53px);
      padding-bottom: 2.5rem;
      overflow: auto;
      background: var(--background2);
      margin-bottom: 0;
    }
    .tabs-statement.demo-tabs {
      background: var(--background1);
      & .el-tabs__nav-wrap {
        padding: 0;
        .el-tabs__nav-scroll {
          overflow: auto;
        }
        & .el-tabs__nav {
          width: 100%;
        }
        & .el-tabs__active-bar {
          width: 25%;
          background-color: var(--selected);
        }
        & .el-tabs__item.is-active {
          color: var(--selected);
        }
        & .el-tabs__item {
          width: 25%;
          text-align: center;
          padding-left: 14px !important;
          padding-right: 14px !important;
        }
      }
    }
    .demo-tabs {
      background: var(--background1);
      position: relative;
      z-index: 98;
      & .el-tabs__nav-wrap {
        padding: 0;

        & .el-tabs__nav {
          width: 100%;
        }
        & .el-tabs__active-bar {
          width: 50%;
          background-color: var(--secondary);
        }
        & .el-tabs__item.is-active {
          color: var(--secondary);
        }
        & .el-tabs__item {
          width: 50%;
          text-align: center;
          padding-left: 14px !important;
          padding-right: 14px !important;
        }
      }
    }
    .flex.flex-col.p-5.space-y-2.bg-background2 {
      height: calc(100vh - 52px);
      height: calc(100svh - 52px);
      background: var(--background1);
      .balance-box {
        border: 1px solid var(--border);
        h2 {
          color: var(--secondary);
          line-height: 33px;
          font-weight: 700;
          font-size: 28px;
        }
      }
      button.wallet-deposit-btn.el-button {
        width: 100%;
        height: 40px;
        background-color: var(--primary);
        border: none;
        margin-left: 0;
      }
      .el-button span {
        @apply text-xs font-bold leading-[14px];
        color: var(--textBtn);
      }
      button.wallet-withdrawal-btn.el-button {
        width: 65%;
        height: 40px;
        background-color: var(--primary);
        border: none;
        margin-left: 8px;
        span {
          overflow: hidden;
          text-overflow: ellipsis;
          display: block;
        }
      }
    }
    .flex.flex-col.p-5.space-y-2.bg-background3 {
      height: calc(100vh - 52px);
      height: calc(100svh - 52px);
      background: var(--background3);
      .balance-box {
        border: 1px solid var(--border);
        background: var(--background1);
        h2 {
          color: var(--secondary);
          line-height: 33px;
          font-weight: 700;
          font-size: 28px;
        }
      }
      button.wallet-deposit-btn.el-button {
        width: 35%;
        height: 40px;
        background-color: var(--primary);
        border: none;
        margin-left: 0;
      }
      .el-button span {
        @apply text-xs font-bold leading-[14px];
        color: var(--textBtn);
      }
      button.wallet-withdrawal-btn.el-button {
        width: 65%;
        height: 40px;
        background-color: var(--primary);
        border: none;
        margin-left: 8px;
        span {
          overflow: hidden;
          text-overflow: ellipsis;
          display: block;
        }
      }
    }
    .fixed-header {
      // position: unset;
      .el-tabs.el-tabs--top {
        & .el-tabs__nav-wrap {
          padding: 0;

          & .el-tabs__nav {
            width: 100%;
          }
          & .el-tabs__active-bar {
            width: 33.3333%;
            background-color: var(--secondary);
          }
          & .el-tabs__item.is-active {
            color: var(--secondary);
          }
          & .el-tabs__item {
            width: 33.3333%;
            text-align: center;
            padding-left: 14px !important;
            padding-right: 14px !important;
          }
        }
      }
    }
    .overflow-auto.mt-\[48px\] {
      height: calc(100vh - 90px);
      overflow: auto;
    }

    .payment-bank-menu {
      color: var(--text);
      border-bottom: 2px solid transparent;
    }
    .payment-bank-menu.selected-tab {
      color: var(--secondary);
      font-weight: 500;
      border-color: var(--secondary);
    }
    .divider-y.mb-\[12vw\] {
      height: calc(100vh - 53px);
      padding-bottom: 6.8rem;
      overflow: auto;
      background: var(--background2);
      margin-bottom: 0;
      .px-5.py-6.space-y-4 {
        background: var(--background2);
      }
      & h5 {
        color: var(--hint);
      }
      .el-radio-button {
        --el-radio-button-checked-border-color: var(--primary);
        --el-radio-button-checked-bg-color: rgb(0, 0, 0, 0);
        --el-radio-button-checked-text-color: var(--text);
        margin-right: 0;
        height: 100%;
        min-height: 32px;

        .check-img {
          height: 18px !important;
        }
        &.is-active {
          & .el-radio-button__inner {
            @apply w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
            box-shadow: none !important;
            border: var(--secondary) solid 2px;
            white-space: break-spaces;
            color: var(--secondary);
          }
        }
        & .el-radio-button__inner {
          @apply w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
          box-shadow: none !important;
          border: var(--border) solid 2px;
          white-space: break-spaces;
          color: var(--text);
          & img {
            height: 100%;
          }
        }
        & .el-radio-button__inner::before {
          background: var(--secondary) !important;
        }
        .el-radio-button__original-radio:checked + .el-radio-button__inner,
        &:first-child
          .el-radio-button__original-radio:checked
          + .el-radio-button__inner {
          border-color: var(--secondary);
        }
      }
      .slip-card {
        width: 100%;
        height: 132px;

        /* KR Theme/Background1 */

        background: var(--background1);
        /* KR Theme/Border */

        border: 1px dashed #4d5080;
        border-radius: 8px;
      }
      .slip-card button.el-button {
        width: 152px;
        height: 40px;
      }
    }
    .el-button.el-button--primary.is-round {
      width: fit-content;
      height: 40px;
      span {
        font-size: 14px;
        font-weight: 700;
      }
    }
    .el-input__inner {
      height: 48px !important;
      border-radius: 8px;
    }
    .grid.grid-cols-3 {
      .el-radio-button {
        --el-radio-button-checked-border-color: var(--primary);
        --el-radio-button-checked-bg-color: rgb(0, 0, 0, 0);
        --el-radio-button-checked-text-color: var(--text);
        margin-right: 0;
        height: 100%;
        min-height: 32px;
        border-radius: 4px;
        &.is-active {
          & .el-radio-button__inner {
            @apply rounded-lg w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
            box-shadow: none !important;
            border: var(--secondary) solid 1px;
            white-space: break-spaces;
            color: var(--secondary);
          }
        }
        & .el-radio-button__inner {
          @apply rounded-lg w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
          box-shadow: none !important;
          border: var(--border) solid 1px;
          white-space: break-spaces;
          color: var(--text);
        }
        & .el-radio-button__inner::before {
          background: var(--secondary) !important;
        }
        .el-radio-button__original-radio:checked + .el-radio-button__inner,
        &:first-child
          .el-radio-button__original-radio:checked
          + .el-radio-button__inner {
          border-color: var(--secondary);
        }
      }
    }
    .mx-auto.px-5.bg-1 {
      margin-right: 0;
      margin-left: 0;
      background: var(--background2);
      padding: 0;
      .demo-tabs {
        & .el-tabs__nav-wrap {
          padding: 0;
          .el-tabs__nav-scroll {
            overflow: auto;
          }
          & .el-tabs__nav {
            width: 100%;
          }
          & .el-tabs__active-bar {
            width: 25%;
            background-color: var(--secondary);
          }
          & .el-tabs__item.is-active {
            color: var(--secondary);
          }
          & .el-tabs__item {
            min-width: 92px;
            text-align: center;
            padding-left: 14px !important;
            padding-right: 14px !important;
          }
        }
      }
      & .flex-auto {
        padding-left: 8px;
        padding-right: 8px;
        height: calc(100vh - 106px);
        padding-bottom: 5rem;
        overflow: auto;
        .el-card.is-always-shadow {
          background: var(--background1);
          border-radius: 8px;
          button.el-button {
            min-width: 78px;
            height: 30px;
          }
        }
      }
    }
    .flex.flex-col.bg-background2 {
      .el-tabs__header {
        position: sticky;
        top: 52px;
        .el-tabs__item.is-active {
          color: var(--secondary);
        }
        .el-tabs__active-bar {
          background-color: var(--secondary);
        }
      }
      .el-tabs__content {
        margin-top: 0;
        padding-top: 0;
        overflow: auto;
        height: calc(100vh - 98px);
        padding-bottom: 6rem;
        .setting-tab {
          position: unset;
        }
        .el-radio__input.is-checked .el-radio__inner {
          border-color: var(--hint);
          background: var(--hint);
        }
        .el-radio__input.is-checked + .el-radio__label {
          color: var(--hint);
        }
      }
    }
    #header {
      position: sticky;
      top: 0;
      z-index: 99;
    }
  }
  </style>
  <style scoped>
  :deep(.el-collapse-item__wrap),
  :deep(.el-collapse-item__header) {
    border-bottom: unset;
  }
  :deep(.el-icon.el-collapse-item__arrow) {
    display: none;
  }
  :deep(.el-input__suffix) {
    color: var(--secondary);
  }
  </style>
